LeetCode 34. Search for a Range

34. Search for a Range

  • 原题
    Given an array of integers nums sorted in ascending order, find the starting and ending position of a given target value.Your algorithm’s runtime complexity must be in the order of O(log n).
    If the target is not found in the array, return [-1, -1].
    (给定一个升序数组,找到目标值的起始位置和结束位置。时间复杂度需为O(log n)。 如果目标值没找到,返回 [-1, -1] )

  • 思路一
    在有序数组中查找值,首先想到的就是二分查找,但是这道题是需要找到起始位置和结束位置。那么也很容易想到,我通过二分查找找到目标值后,然后以当前目标值的下标为终点,继续向前查找目标值,如此循环直到二分查找没有找到为止。同理,结束位置也是如此的思路。
    AC解一

class Solution {
    public int[] searchRange(int[] nums, int target) {
        int len = nums.length, start = 0, end = len - 1;
        int min, max;
        min = max = find(nums, start, end, target);
        while(true) {
            int minS = find(nums, start, min - 1, target);
            if( minS == -1) break;
            else min = minS;
        }
        while(true) {
            int maxL = find(nums, max + 1, end, target);
            if( maxL == -1) break;
            else max = maxL;
        }
        return new int[]{min, max};
    }

    private int find(int[] nums, int start, int end, int target) {
        while(start <= end) {
            int mid = (start + end) / 2;
            if(target == nums[mid]) return mid; 
            else if(target > nums[mid]) start = mid + 1;
            else end = mid - 1;
        }
        return -1;
    }
}

  • 思路二:
    对二分查找做个变种。当找到目标值时不急着立马返回下标,而是继续向前查找直到找到最小值。其中的关键点就是将小于等于目标值这两种情况合并起来判断,并让 end = mid,而不再是 end = mid - 1,因为此时 target <= nums[mid] ,所以你无法将 end = mid - 1。
    其实就是对思路一的简化。至于最大下标则是查找比目标值大1的数的下标减1 ,即 find(nums, target + 1) - 1。
    AC解
class Solution {
    public int[] searchRange(int[] nums, int target) {
        int s = find(nums, target);
        if(s == nums.length || nums[s] != target) return new int[]{-1, -1};
        if(s == nums.length - 1) return new int[]{s, s};
        return new int[]{s, find(nums, target + 1) - 1};
    }

    private int find(int[] nums, int target) {
        int start = 0, end = nums.length;
        while(start < end) {
            int mid = (end + start) / 2;
            if(target > nums[mid]) start = mid + 1;
            else end = mid;
        }
        return start;
    }
}
Leetcode 443题是关于压缩字符串的问题。题目要求我们对给定的字符数组进行原地修改,使其变为压缩后的形式,并返回压缩后的数组长度。 解题的思路是使用双指针来遍历数组。指针j从第二个元素开始遍历,判断当前元素是否与前一个元素相同。如果相同,则计数器count加1;如果不同,则需要将计数的字符放在后面,并更新指针i的位置。当计数器count大于1时,需要将count转换为字符串,并依次放在后面的位置上。最后返回指针i的位置,即为压缩后的数组长度。 下面是示例代码: ``` class Solution(object): def compress(self, chars): n = len(chars) count = 1 i = 0 for j in range(1, n): if j < n and chars[j-1 == chars[j]: count += 1 else: chars[i = chars[j-1] i += 1 if count > 1: for m in str(count): chars[i = m i += 1 count = 1 return i ``` 这样就可以实现对给定字符数组的原地压缩,并返回压缩后的数组长度。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* *2* [LeetCode第 443 题:压缩字符串(C++)](https://blog.csdn.net/qq_32523711/article/details/109106406)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] - *3* [LeetCode刷题记录——第443题(压缩字符串)](https://blog.csdn.net/bulo1025/article/details/86561588)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值